=== modified file '.bzrignore'
--- .bzrignore	2007-09-02 15:42:18 +0000
+++ .bzrignore	2008-06-28 20:24:16 +0000
@@ -10,3 +10,4 @@
 bzr-gtk.trunk-matkor.e3p
 bzr-gtk.trunk-matkor.e3s
 bzr-gtk.trunk-matkor.e3t
+credits.pickle

=== modified file 'HACKING'
--- HACKING	2007-07-15 15:05:06 +0000
+++ HACKING	2008-07-17 11:51:03 +0000
@@ -8,4 +8,8 @@
 (http://developer.gnome.org/projects/gup/hig/) should be followed where 
 possible.
 
+Several parts of bzr-gtk are currently using glade. However, we are slowly
+trying to move away from glade so please don't add new code that uses glade and
+try to remove the use of glade.
+
 Please update the NEWS file when closing bugs or adding new features.

=== modified file 'NEWS'
--- NEWS	2008-06-06 18:04:45 +0000
+++ NEWS	2008-07-01 21:56:25 +0000
@@ -4,18 +4,52 @@
 
   * Added Refresh menu option with F5 keyboard shortcut (Russ Brown)
 
+  * Show progress bars in bzr viz window (Chad Miller, Jelmer Vernooij)
+
+  * Added menu option for indexing branches if bzr-search is present.
+    (Jelmer Vernooij)
+
+  * Add "Send Merge Directive" button in bzr viz. (Jelmer Vernooij)
+
  BUG FIXES
 
   * Replace _() calls by _i18n() calls. (Vincent Ladeuil, #187283)
   
   * Fixed adding tags. (Javier Derderian, #228709)
 
+  * Fix history mode button. (Jasper Groenewegen, #144962)
+
+  * Fixed handle-patch script. (Jelmer Vernooij)
+
+  * Fix import in olive. (Jelmer Vernooij, #223935)
+
+  * Avoid use of removed smart_add. (Jelmer Vernooij, #244025, #244027)
+
+  * Remove use of upstream removed Repository.revision_parents() 
+    (Jelmer Vernooij)
+
+  * List network drives in Olive. (Kevin Light, #244308)
+
+ CHANGES
+
+  * Moved notify icon code to separate script. (Jelmer Vernooij)
+
+  * Verify testaments when showing signatures on revisions and
+    re-enable signature display. (Jelmer Vernooij)
+
+  * Show credits for bzr-gtk in the about dialog. (Jelmer Vernooij)
+
  INTERNALS
 
   * All i18n calls should now go through _i18n which must be imported from
     bzrlib.plugins.gtk. This addresses the occasional collisions with '_' used
     as an anonymous variable. (Vincent Ladeuil)
 
+  * Add test for linegraph code. (Jelmer Vernooij)
+
+  * Remove obsolete tortoisebzr tests. (Jelmer Vernooij)
+
+  * Share revision context menu and main revision menu in bzr viz. (Jelmer Vernooij)
 
 0.94.0    2008-05-04
 

=== modified file '__init__.py'
--- __init__.py	2008-06-27 16:53:56 +0000
+++ __init__.py	2008-06-27 17:10:27 +0000
@@ -15,7 +15,6 @@
 """Graphical support for Bazaar using GTK.
 
 This plugin includes:
-commit-notify     Start the graphical notifier of commits.
 gannotate         GTK+ annotate. 
 gbranch           GTK+ branching. 
 gcheckout         GTK+ checkout. 
@@ -525,77 +524,6 @@
     register_command(cmd)
 
 
-class cmd_commit_notify(GTKCommand):
-    """Run the bzr commit notifier.
-
-    This is a background program which will pop up a notification on the users
-    screen when a commit occurs.
-    """
-
-    def run(self):
-        from notify import NotifyPopupMenu
-        gtk = open_display()
-        menu = NotifyPopupMenu()
-        icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
-        icon.connect('popup-menu', menu.display)
-
-        import cgi
-        import dbus
-        import dbus.service
-        import pynotify
-        from bzrlib.bzrdir import BzrDir
-        from bzrlib import errors
-        from bzrlib.osutils import format_date
-        from bzrlib.transport import get_transport
-        if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
-            import dbus.glib
-        BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
-        bus = dbus.SessionBus()
-
-        def catch_branch(revision_id, urls):
-            # TODO: show all the urls, or perhaps choose the 'best'.
-            url = urls[0]
-            try:
-                if isinstance(revision_id, unicode):
-                    revision_id = revision_id.encode('utf8')
-                transport = get_transport(url)
-                a_dir = BzrDir.open_from_transport(transport)
-                branch = a_dir.open_branch()
-                revno = branch.revision_id_to_revno(revision_id)
-                revision = branch.repository.get_revision(revision_id)
-                summary = 'New revision %d in %s' % (revno, url)
-                body  = 'Committer: %s\n' % revision.committer
-                body += 'Date: %s\n' % format_date(revision.timestamp,
-                    revision.timezone)
-                body += '\n'
-                body += revision.message
-                body = cgi.escape(body)
-                nw = pynotify.Notification(summary, body)
-                def start_viz(notification=None, action=None, data=None):
-                    """Start the viz program."""
-                    pp = start_viz_window(branch, revision_id)
-                    pp.show()
-                def start_branch(notification=None, action=None, data=None):
-                    """Start a Branch dialog"""
-                    from bzrlib.plugins.gtk.branch import BranchDialog
-                    bd = BranchDialog(remote_path=url)
-                    bd.run()
-                nw.add_action("inspect", "Inspect", start_viz, None)
-                nw.add_action("branch", "Branch", start_branch, None)
-                nw.set_timeout(5000)
-                nw.show()
-            except Exception, e:
-                print e
-                raise
-        bus.add_signal_receiver(catch_branch,
-                                dbus_interface=BROADCAST_INTERFACE,
-                                signal_name="Revision")
-        pynotify.init("bzr commit-notify")
-        gtk.main()
-
-register_command(cmd_commit_notify)
-
-
 class cmd_gselftest(GTKCommand):
     """Version of selftest that displays a notification at the end"""
 

=== modified file 'about.py'
--- about.py	2008-04-01 09:59:41 +0000
+++ about.py	2008-06-28 20:24:16 +0000
@@ -23,15 +23,45 @@
 import bzrlib
 import gtk
 import os
+from bzrlib.branch import Branch
+from bzrlib.errors import NotBranchError, NoRepositoryPresent
+from bzrlib.trace import mutter
+
 from bzrlib.plugins.gtk import icon_path
 
+
+def read_license():
+    license_file = os.path.join(os.path.dirname(__file__), "COPYING")
+    if os.path.exists(license_file):
+        return file(license_file).read()
+    # Fall back to just license name if we can't find the file
+    return "GPLv2 or later"
+
+
+def load_credits():
+    import pickle
+    try:
+        credits = pickle.load(file("credits.pickle"))
+    except IOError:
+        credits = None
+    return credits
+
+
 class AboutDialog(gtk.AboutDialog):
     def __init__(self):
         super(AboutDialog, self).__init__()
         self.set_name("Bazaar GTK")
         self.set_version(bzrlib.plugins.gtk.version_string)
         self.set_website("http://bazaar-vcs.org/BzrGtk")
-        self.set_license("GNU GPL v2 or later")
-        self.set_icon(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        self.set_license(read_license())
+        self.set_logo(gtk.gdk.pixbuf_new_from_file(icon_path("bzr-icon-64.png")))
+        credits = load_credits()
+        if credits is not None:
+            (authors, documenters, artists, translators) = credits
+            self.set_authors(authors)
+            self.set_documenters(documenters)
+            self.set_artists(artists)
+            self.set_translator_credits("\n".join(translators))
         self.connect ("response", lambda d, r: d.destroy())
 
+

=== modified file 'branchview/linegraph.py'
--- branchview/linegraph.py	2008-06-29 18:12:29 +0000
+++ branchview/linegraph.py	2008-06-30 12:39:07 +0000
@@ -47,7 +47,7 @@
     def update_root_progress(step_number):
         """IFF our container received a root progress bar, then update it."""
         if root_progress is not None:
-            root_progress.update(current_cnt=step_number)
+            root_progress.update(None, current_cnt=step_number)
 
     graph_parents = {}
     ghosts = set()

=== modified file 'branchview/treeview.py'
--- branchview/treeview.py	2008-06-29 18:12:29 +0000
+++ branchview/treeview.py	2008-06-30 20:11:24 +0000
@@ -405,9 +405,9 @@
             self.emit('revision-selected')
 
     def _on_revision_selected(self, widget, event):
-        from bzrlib.plugins.gtk.revisionmenu import RevisionPopupMenu
+        from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
         if event.button == 3:
-            menu = RevisionPopupMenu(self.branch.repository, 
+            menu = RevisionMenu(self.branch.repository, 
                 [self.get_revision().revision_id],
                 self.branch)
             menu.connect('tag-added', lambda w, t, r: self.add_tag(t, r))

=== added file 'bzr-notify'
--- bzr-notify	1970-01-01 00:00:00 +0000
+++ bzr-notify	2008-06-27 17:10:27 +0000
@@ -0,0 +1,72 @@
+#!/usr/bin/env python
+
+"""Run the bzr tray icon.
+
+This is a background program which will pop up a notification on the users
+screen when a commit occurs.
+"""
+
+from bzrlib.plugin import load_plugins
+load_plugins()
+
+from bzrlib.plugins.gtk import open_display, icon_path
+
+from notify import NotifyPopupMenu
+gtk = open_display()
+menu = NotifyPopupMenu()
+icon = gtk.status_icon_new_from_file(icon_path("bzr-icon-64.png"))
+icon.connect('popup-menu', menu.display)
+
+import cgi
+import dbus
+import dbus.service
+import pynotify
+from bzrlib.bzrdir import BzrDir
+from bzrlib import errors
+from bzrlib.osutils import format_date
+from bzrlib.transport import get_transport
+if getattr(dbus, 'version', (0,0,0)) >= (0,41,0):
+	import dbus.glib
+BROADCAST_INTERFACE = "org.bazaarvcs.plugins.dbus.Broadcast"
+bus = dbus.SessionBus()
+
+def catch_branch(revision_id, urls):
+	# TODO: show all the urls, or perhaps choose the 'best'.
+	url = urls[0]
+	try:
+		if isinstance(revision_id, unicode):
+			revision_id = revision_id.encode('utf8')
+		transport = get_transport(url)
+		a_dir = BzrDir.open_from_transport(transport)
+		branch = a_dir.open_branch()
+		revno = branch.revision_id_to_revno(revision_id)
+		revision = branch.repository.get_revision(revision_id)
+		summary = 'New revision %d in %s' % (revno, url)
+		body  = 'Committer: %s\n' % revision.committer
+		body += 'Date: %s\n' % format_date(revision.timestamp,
+			revision.timezone)
+		body += '\n'
+		body += revision.message
+		body = cgi.escape(body)
+		nw = pynotify.Notification(summary, body)
+		def start_viz(notification=None, action=None, data=None):
+			"""Start the viz program."""
+			pp = start_viz_window(branch, revision_id)
+			pp.show()
+		def start_branch(notification=None, action=None, data=None):
+			"""Start a Branch dialog"""
+			from bzrlib.plugins.gtk.branch import BranchDialog
+			bd = BranchDialog(remote_path=url)
+			bd.run()
+		nw.add_action("inspect", "Inspect", start_viz, None)
+		nw.add_action("branch", "Branch", start_branch, None)
+		nw.set_timeout(5000)
+		nw.show()
+	except Exception, e:
+		print e
+		raise
+bus.add_signal_receiver(catch_branch,
+						dbus_interface=BROADCAST_INTERFACE,
+						signal_name="Revision")
+pynotify.init("bzr-notify")
+gtk.main()

=== added file 'create-credits.py'
--- create-credits.py	1970-01-01 00:00:00 +0000
+++ create-credits.py	2008-06-28 20:24:16 +0000
@@ -0,0 +1,26 @@
+#!/usr/bin/python
+# Copyright (C) 2008 Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+from bzrlib.branch import Branch
+from bzrlib.plugins.stats import find_credits
+
+import pickle
+
+branch = Branch.open(".")
+credits = find_credits(branch.repository, branch.last_revision())
+
+pickle.dump(credits, file("credits.pickle", 'w'))

=== modified file 'olive/__init__.py'
--- olive/__init__.py	2008-06-23 08:05:19 +0000
+++ olive/__init__.py	2008-07-17 20:41:24 +0000
@@ -442,6 +442,9 @@
             # History Mode deactivated
             self.entry_history.set_sensitive(False)
             self.button_history.set_sensitive(False)
+            
+            # Return right window to normal view by acting like we jump to it
+            self.on_button_location_jump_clicked(widget)
     
     @show_bzr_error
     def on_entry_history_revno_key_press_event(self, widget, event):
@@ -467,10 +470,13 @@
     
     def on_menuitem_add_files_activate(self, widget):
         """ Add file(s)... menu handler. """
-        from add import OliveAdd
-        add = OliveAdd(self.wt, self.wtpath, self.get_selected_right())
-        add.display()
-    
+        from bzrlib.plugins.gtk.olive.add import AddDialog
+        add = AddDialog(self.wt, self.wtpath, self.get_selected_right(), self.window)
+        response = add.run()
+        add.destroy()
+        if response == gtk.RESPONSE_OK:
+            self.refresh_right()
+
     def on_menuitem_branch_get_activate(self, widget):
         """ Branch/Get... menu handler. """
         from bzrlib.plugins.gtk.branch import BranchDialog
@@ -773,7 +779,8 @@
         else:
             branch = self.remote_branch
 
-        window = branchwin.BranchWindow(branch, branch.last_revision(), None, parent=self.window)
+        window = branchwin.BranchWindow(branch, [branch.last_revision()], None, 
+                                        parent=self.window)
         window.show()
     
     def on_menuitem_view_refresh_activate(self, widget):
@@ -1485,7 +1492,8 @@
         
         driveletters = []
         for drive in string.ascii_uppercase:
-            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED:
+            if win32file.GetDriveType(drive+':') == win32file.DRIVE_FIXED or\
+                win32file.GetDriveType(drive+':') == win32file.DRIVE_REMOTE:
                 driveletters.append(drive+':')
         return driveletters
     

=== modified file 'olive/add.py'
--- olive/add.py	2008-05-05 18:16:46 +0000
+++ olive/add.py	2008-07-17 20:41:24 +0000
@@ -23,44 +23,52 @@
     pass
 
 import gtk
-import gtk.glade
 
 import bzrlib.add
 import bzrlib.errors as errors
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from guifiles import GLADEFILENAME
-
-
-class OliveAdd:
-    """ Display the Add file(s) dialog and perform the needed actions. """
-    def __init__(self, wt, wtpath, selected=[]):
-        """ Initialize the Add file(s) dialog. """
-        self.glade = gtk.glade.XML(GLADEFILENAME, 'window_add', 'olive-gtk')
-        
-        self.window = self.glade.get_widget('window_add')
-        
-        # Dictionary for signal_autoconnect
-        dic = { "on_button_add_add_clicked": self.add,
-                "on_button_add_cancel_clicked": self.close }
-        
-        # Connect the signals to the handlers
-        self.glade.signal_autoconnect(dic)
-
+from bzrlib.plugins.gtk.errors import show_bzr_error
+
+
+class AddDialog(gtk.Dialog):
+    """ Dialog for adding selected file or recursively all unknown files/folders in branch """
+    
+    def __init__(self, wt, wtpath, selected, parent=None):
+        """ Initialize the Add dialog. """
+        gtk.Dialog.__init__(self, title="Olive - Add file(s)",
+                                  parent=parent,
+                                  flags=0,
+                                  buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+        
+        # Get arguments
         self.wt = wt
         self.wtpath = wtpath
         self.selected = selected
-
-    def display(self):
-        """ Display the Add file(s) dialog. """
-        self.window.show_all()
-        
-    def add(self, widget):
-        radio_selected = self.glade.get_widget('radiobutton_add_selected')
-        radio_unknown = self.glade.get_widget('radiobutton_add_unknown')
-        
-        if radio_selected.get_active():
+        
+        # Create widgets
+        self._label_add_question = gtk.Label(_i18n("Which file(s) do you want to add?"))
+        self._radiobutton_add_selected = gtk.RadioButton(None,_i18n("Selected: %s"%self.selected))
+        self._radiobutton_add_unknown = gtk.RadioButton(self._radiobutton_add_selected, 
+                                                        _i18n("All unknowns recursively"))
+        self._button_add = gtk.Button(stock=gtk.STOCK_ADD)        
+        
+        self._button_add.connect('clicked', self._on_add_clicked)
+        
+        # Add widgets to dialog window and decorate
+        self.vbox.add(self._label_add_question)
+        self.vbox.add(self._radiobutton_add_selected)
+        self.vbox.add(self._radiobutton_add_unknown)
+        self.vbox.set_spacing(3)
+        self.action_area.pack_end(self._button_add)
+        
+        self.vbox.show_all()
+        
+    @show_bzr_error
+    def _on_add_clicked(self, button):
+        """ """
+        if self._radiobutton_add_selected.get_active():
             # Add only the selected file
             filename = self.selected
             
@@ -69,26 +77,19 @@
                              _i18n('Please select a file from the list,\nor choose the other option.'))
                 return
             
-            fullpath = self.wt.abspath(os.path.join(self.wtpath, filename))
-            
             try:
-                bzrlib.add.smart_add([fullpath])
+                self.wt.add([filename])
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
-        elif radio_unknown.get_active():
+        elif self._radiobutton_add_unknown.get_active():
             # Add unknown files recursively
-            fullpath = self.wt.abspath(self.wtpath)
-            
             try:
-                bzrlib.add.smart_add([fullpath], True)
+                self.wt.add(self.wt.unknowns())
             except errors.NotBranchError:
                 error_dialog(_i18n('Directory is not a branch'),
                              _i18n('You can perform this action only in a branch.'))
                 return
         
-        self.close()
-    
-    def close(self, widget=None):
-        self.window.destroy()
+        self.response(gtk.RESPONSE_OK)

=== modified file 'olive/menu.py'
--- olive/menu.py	2008-05-05 18:18:08 +0000
+++ olive/menu.py	2008-06-30 12:15:06 +0000
@@ -30,13 +30,12 @@
 import bzrlib.errors as errors
 from bzrlib.workingtree import WorkingTree
 
-from bzrlib.plugins.gtk import _i18n
+from bzrlib.plugins.gtk import _i18n, launch
 from bzrlib.plugins.gtk.dialog import error_dialog, info_dialog, question_dialog, warning_dialog
 from bzrlib.plugins.gtk.errors import show_bzr_error
 from bzrlib.plugins.gtk.annotate.gannotate import GAnnotateWindow
 from bzrlib.plugins.gtk.annotate.config import GAnnotateConfig
 from bzrlib.plugins.gtk.diff import DiffWindow
-from launch import launch
 from bzrlib.plugins.gtk.olive import Preferences
 
 class OliveMenu:
@@ -179,7 +178,8 @@
                          _i18n('Please select a file from the list,\nor choose the other option.'))
             return
         
-        bzrlib.add.smart_add([os.path.join(directory, filename)])
+        wt, path = WorkingTree.open_containing(os.path.join(directory, filename))
+        wt.add([path])
     
     @show_bzr_error
     def annotate(self, action):

=== modified file 'olive/move.py'
--- olive/move.py	2008-05-05 18:16:46 +0000
+++ olive/move.py	2008-06-28 16:59:50 +0000
@@ -31,7 +31,7 @@
 
 from bzrlib.plugins.gtk import _i18n
 from bzrlib.plugins.gtk.dialog import error_dialog
-from errors import show_bzr_error
+from bzrlib.plugins.gtk.errors import show_bzr_error
 from guifiles import GLADEFILENAME
 
 

=== modified file 'revisionmenu.py'
--- revisionmenu.py	2008-01-23 16:36:21 +0000
+++ revisionmenu.py	2008-07-01 21:54:21 +0000
@@ -27,7 +27,7 @@
 from bzrlib import (errors, ui)
 from bzrlib.revision import NULL_REVISION
 
-class RevisionPopupMenu(gtk.Menu):
+class RevisionMenu(gtk.Menu):
 
     __gsignals__ = {
             'tag-added': (
@@ -37,11 +37,18 @@
             )
     }
 
-    def __init__(self, repository, revids, branch=None, wt=None):
-        super(RevisionPopupMenu, self).__init__()
+    def __init__(self, repository, revids, branch=None, wt=None, parent=None):
+        super(RevisionMenu, self).__init__()
+        self._parent = parent
         self.branch = branch
         self.repository = repository
         self.wt = wt
+        self.set_revision_ids(revids)
+
+    def set_revision_ids(self, revids):
+        assert isinstance(revids, list)
+        for c in self.get_children():
+            self.remove(c)
         self.revids = revids
         self.create_items()
 
@@ -50,44 +57,55 @@
             item = gtk.MenuItem("View _Changes")
             item.connect('activate', self.show_diff)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Push")
             item.connect('activate', self.show_push)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Tag Revision")
             item.connect('activate', self.show_tag)
             self.append(item)
-            self.show_all()
 
             item = gtk.MenuItem("_Merge Directive")
             item.connect('activate', self.store_merge_directive)
             # FIXME: self.append(item)
-            self.show_all()
+
+            item = gtk.MenuItem("_Send Merge Directive")
+            item.connect('activate', self.send_merge_directive)
+            self.append(item)
             
             if self.wt:
                 item = gtk.MenuItem("_Revert to this revision")
                 item.connect('activate', self.revert)
                 self.append(item)
-                self.show_all()
+
+        self.show_all()
 
     def store_merge_directive(self, item):
         from bzrlib.plugins.gtk.mergedirective import CreateMergeDirectiveDialog
         window = CreateMergeDirectiveDialog(self.branch, self.revids[0])
         window.show()
 
+    def send_merge_directive(self, item):
+        from bzrlib.plugins.gtk.mergedirective import SendMergeDirectiveDialog
+        from cStringIO import StringIO
+        window = SendMergeDirectiveDialog(self.branch, self.revids[0])
+        if window.run() == gtk.RESPONSE_OK:
+            outf = StringIO()
+            outf.writelines(window.get_merge_directive().to_lines())
+            mail_client = self.branch.get_config().get_mail_client()
+            mail_client.compose_merge_request(window.get_mail_to(), "[MERGE]",
+                                              outf.getvalue())
+        window.destroy()
+
     def show_diff(self, item):
         from bzrlib.plugins.gtk.diff import DiffWindow
-        window = DiffWindow(parent=self.parent)
-        parentids = self.repository.revision_parents(self.revids[0])
-
+        window = DiffWindow(parent=self._parent)
+        parentids = self.repository.get_revision(self.revids[0]).parent_ids
         if len(parentids) == 0:
             parentid = NULL_REVISION
         else:
             parentid = parentids[0]
-
         rev_tree    = self.repository.revision_tree(self.revids[0])
         parent_tree = self.repository.revision_tree(parentid)
         window.set_diff(self.revids[0], rev_tree, parent_tree)

=== modified file 'revisionview.py'
--- revisionview.py	2008-06-24 10:34:38 +0000
+++ revisionview.py	2008-06-29 19:18:34 +0000
@@ -22,9 +22,11 @@
 import gobject
 import webbrowser
 
-from bzrlib.plugins.gtk import icon_path
 from bzrlib.osutils import format_date
 from bzrlib.util.bencode import bdecode
+from bzrlib.testament import Testament
+
+from bzrlib.plugins.gtk import icon_path
 
 try:
     from bzrlib.plugins.gtk import seahorse
@@ -220,7 +222,17 @@
                                         "This revision has not been signed.")
 
     def show_signature(self, crypttext):
-        key = seahorse.verify(crypttext)
+        (cleartext, key) = seahorse.verify(crypttext)
+
+        assert cleartext is not None
+
+        inv = self.repository.get_inventory(self.revision.revision_id)
+        expected_testament = Testament(self.revision, inv).as_short_text()
+        if expected_testament != cleartext:
+            self.signature_image.set_from_file(icon_path("sign-bad.png"))
+            self.signature_label.set_markup("<b>Signature does not match repository data</b>\n" +
+                        "The signature plaintext is different from the expected testament plaintext.")
+            return
 
         if key and key.is_available():
             if key.is_trusted():
@@ -322,8 +334,8 @@
         self._create_general()
         self._create_relations()
         # Disabled because testaments aren't verified yet:
-        # if has_seahorse:
-        #    self._create_signature()
+        if has_seahorse:
+            self._create_signature()
         self._create_file_info_view()
         self._create_bugs()
 

=== modified file 'seahorse.py'
--- seahorse.py	2008-06-20 03:33:17 +0000
+++ seahorse.py	2008-06-29 19:07:23 +0000
@@ -85,7 +85,10 @@
         if key not in keyset:
             keyset[key] = Key(key)
 
-        return keyset[key]
+        return (cleartext, keyset[key])
+
+    return (cleartext, None)
+
 
 class Key:
 

=== added file 'search.py'
--- search.py	1970-01-01 00:00:00 +0000
+++ search.py	2008-07-01 15:28:30 +0000
@@ -0,0 +1,88 @@
+# Copyright (C) 2008 by Jelmer Vernooij <jelmer@samba.org>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+
+import gobject, gtk
+from bzrlib.plugins.search import index as _mod_index
+
+
+class SearchDialog(gtk.Dialog):
+    """Search dialog."""
+    def __init__(self, branch, parent=None):
+        gtk.Dialog.__init__(self, title="Search Revisions",
+                                  parent=parent,
+                                  flags=gtk.DIALOG_MODAL,
+                                  buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK,
+                                           gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
+    
+        # Get arguments
+        self.branch = branch
+
+        self.index = _mod_index.open_index_url(branch.base)
+
+        self.searchbar = gtk.HBox()
+        self.searchentry = gtk.Entry()
+        self.searchentry.connect('activate', self._searchentry_activate)
+        # TODO: Completion using the bzr-search suggests functionality
+        self.searchbar.add(self.searchentry)
+        self.vbox.pack_start(self.searchbar, expand=False, fill=False)
+
+        self.results_model = gtk.ListStore(gobject.TYPE_STRING, gobject.TYPE_STRING, gobject.TYPE_PYOBJECT)
+        self.results_treeview = gtk.TreeView(self.results_model)
+
+        documentname_column = gtk.TreeViewColumn("Document", gtk.CellRendererText(), text=0)
+        self.results_treeview.append_column(documentname_column)
+
+        summary_column = gtk.TreeViewColumn("Summary", gtk.CellRendererText(), text=1)
+        self.results_treeview.append_column(summary_column)
+
+        results_scrolledwindow = gtk.ScrolledWindow()
+        results_scrolledwindow.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
+        results_scrolledwindow.add(self.results_treeview)
+
+        self.vbox.pack_start(results_scrolledwindow, expand=True, fill=True)
+
+        self.set_default_size(600, 400)
+        # Show the dialog
+        self.show_all()
+
+    def get_revision(self):
+        (path, focus) = self.results_treeview.get_cursor()
+        if path is None:
+            return None
+        iter = self.results_model.get_iter(path)
+        return self.results_model.get_value(iter, 2)
+
+    def _searchentry_activate(self, entry):
+        self.results_model.clear()
+        self.index._branch.lock_read()
+        try:
+            query = [(query_item,) for query_item in self.searchentry.get_text().split(" ")]
+            for result in self.index.search(query):
+                if isinstance(result, _mod_index.FileTextHit):
+                    revid = result.text_key[-1]
+                elif isinstance(result, _mod_index.RevisionHit):
+                    revid = result.revision_key[0]
+                else:
+                    raise AssertionError()
+                self.results_model.append([result.document_name(), result.summary(), revid])
+        finally:
+            self.index._branch.unlock()

=== modified file 'setup.py'
--- setup.py	2008-06-27 16:53:56 +0000
+++ setup.py	2008-06-27 17:32:10 +0000
@@ -96,7 +96,7 @@
     maintainer_email = "jelmer@samba.org",
     description = "GTK+ Frontends for various Bazaar commands",
     license = "GNU GPL v2 or later",
-    scripts=['olive-gtk', 'bzr-handle-patch'],
+    scripts=['olive-gtk', 'bzr-handle-patch', 'bzr-notify'],
     package_dir = {
         "bzrlib.plugins.gtk": ".",
         "bzrlib.plugins.gtk.viz": "viz", 

=== modified file 'status.py'
--- status.py	2008-05-05 18:16:46 +0000
+++ status.py	2008-07-08 21:40:38 +0000
@@ -28,12 +28,13 @@
     """ Display Status window and perform the needed actions. """
     def __init__(self, wt, wtpath, revision=None):
         """ Initialize the Status window. """
-        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
+        super(StatusDialog, self).__init__(flags=gtk.DIALOG_MODAL, buttons=(gtk.STOCK_CLOSE, gtk.RESPONSE_CLOSE))
         self.set_title("Working tree changes")
+        self.set_default_response(gtk.RESPONSE_CLOSE)
         self._create()
         self.wt = wt
         self.wtpath = wtpath
-        
+
         if revision is None:
             revision = self.wt.branch.last_revision()
             
@@ -44,13 +45,22 @@
 
     def _create(self):
         self.set_default_size(400, 300)
-        scrolledwindow = gtk.ScrolledWindow()
-        scrolledwindow.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        self.set_has_separator(False)
+        sw = gtk.ScrolledWindow()
+        sw.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
+        sw.set_shadow_type(gtk.SHADOW_IN)
         self.treeview = gtk.TreeView()
-        scrolledwindow.add(self.treeview)
-        self.vbox.pack_start(scrolledwindow, True, True)
+        sw.add(self.treeview)
+        self.vbox.pack_start(sw, True, True)
         self.vbox.show_all()
 
+        # sane border and spacing widths (as recommended by GNOME HIG) 
+        self.set_border_width(5)
+        sw.set_border_width(5)
+        self.vbox.set_spacing(2)
+        self.action_area.set_border_width(5)
+
+
     def row_diff(self, tv, path, tvc):
         file = self.model[path][1]
         if file is None:
@@ -61,6 +71,7 @@
         window.set_file(file)
         window.show()
 
+
     def _generate_status(self):
         """ Generate 'bzr status' output. """
         self.model = gtk.TreeStore(str, str)

=== modified file 'tests/__init__.py'
--- tests/__init__.py	2008-06-29 15:54:40 +0000
+++ tests/__init__.py	2008-06-29 22:44:42 +0000
@@ -32,9 +32,6 @@
         'test_history',
         ]
 
-    if os.name == 'nt':
-        testmod_names.append("test_tortoise_bzr")
-
     result.addTest(loader.loadTestsFromModuleNames(["%s.%s" % (__name__, i) for i in testmod_names]))
     return result
 

=== removed file 'tests/test_tortoise_bzr.py'
--- tests/test_tortoise_bzr.py	2007-03-15 12:43:48 +0000
+++ tests/test_tortoise_bzr.py	1970-01-01 00:00:00 +0000
@@ -1,28 +0,0 @@
-# Copyright (C) 2007 Jelmer Vernooij <jelmer@samba.org>
-#
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation; either version 2 of the License, or
-# (at your option) any later version.
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-
-from bzrlib.tests import TestCaseInTempDir
-from bzrlib import config
-
-import win32com.client as client
-
-class TestsShellExtension(TestCaseInTempDir):
-    def setUp(self):
-        super(TestsUrlHistory, self).setUp()
-        self.ext = client.Dispatch("Bazaar.ShellExtension.ContextMenu")
-
-    def test_get_command_string(self):
-        self.assertEqual(u"Hello from Python!!", self.ext.GetCommandString(1,1))

=== modified file 'ui.py'
--- ui.py	2008-06-29 18:12:29 +0000
+++ ui.py	2008-06-30 20:32:25 +0000
@@ -72,8 +72,10 @@
 
 
 class ProgressBarWindow(gtk.Window):
-    def __init__(self):
+    def __init__(self, to_file=None, show_pct=None, show_spinner=None, show_eta=None, 
+                 show_bar=None, show_count=None, to_messages_file=None, _stack=None):
         super(ProgressBarWindow, self).__init__(type=gtk.WINDOW_TOPLEVEL)
+        self._stack = _stack
         self.set_border_width(0)
         self.set_title("Progress")
         self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
@@ -83,10 +85,30 @@
         self.set_resizable(False)
         self.show_all()
 
+    def return_pb(self, pb):
+        self._stack.return_pb(self)
+    
+    def update(self, *args, **kwargs):
+        self.pb.update(*args, **kwargs)
+
+    def finished(self):
+        self.pb.finished()
+        self.hide_all()
+ 
     def clear(self):
         self.pb.clear()
         self.destroy()
 
+    def child_progress(self, *args, **kwargs):
+        return self.pb.child_progress(*args, **kwargs)
+
+    def child_update(self, *args, **kwargs):
+        return self.pb.child_update(*args, **kwargs)
+
+    def get_progress_bar(self):
+        self.show_all()
+        return self
+
 
 class ProgressPanel(gtk.HBox):
     def __init__(self):

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2008-06-06 17:46:26 +0000
+++ viz/branchwin.py	2008-07-01 21:54:21 +0000
@@ -13,14 +13,16 @@
 import gobject
 import pango
 
-from bzrlib.plugins.gtk.window import Window
 from bzrlib.plugins.gtk import icon_path
+from bzrlib.plugins.gtk.branchview import TreeView, treemodel
 from bzrlib.plugins.gtk.tags import AddTagDialog
 from bzrlib.plugins.gtk.preferences import PreferencesWindow
-from bzrlib.plugins.gtk.branchview import TreeView, treemodel
+from bzrlib.plugins.gtk.revisionmenu import RevisionMenu
+from bzrlib.plugins.gtk.window import Window
+
+from bzrlib.config import BranchConfig, GlobalConfig
 from bzrlib.revision import Revision, NULL_REVISION
-from bzrlib.config import BranchConfig
-from bzrlib.config import GlobalConfig
+from bzrlib.trace import mutter
 
 class BranchWindow(Window):
     """Branch window.
@@ -202,24 +204,9 @@
         go_menu.add(gtk.SeparatorMenuItem())
         go_menu.add(self.go_menu_tags)
 
-        revision_menu = gtk.Menu()
+        self.revision_menu = RevisionMenu(self.branch.repository, [], self.branch, parent=self)
         revision_menuitem = gtk.MenuItem("_Revision")
-        revision_menuitem.set_submenu(revision_menu)
-
-        revision_menu_diff = gtk.MenuItem("View Changes")
-        revision_menu_diff.connect('activate', 
-                self._menu_diff_cb)
-        
-        revision_menu_compare = gtk.MenuItem("Compare with...")
-        revision_menu_compare.connect('activate',
-                self._compare_with_cb)
-
-        revision_menu_tag = gtk.MenuItem("Tag Revision")
-        revision_menu_tag.connect('activate', self._tag_revision_cb)
-
-        revision_menu.add(revision_menu_tag)
-        revision_menu.add(revision_menu_diff)
-        revision_menu.add(revision_menu_compare)
+        revision_menuitem.set_submenu(self.revision_menu)
 
         branch_menu = gtk.Menu()
         branch_menuitem = gtk.MenuItem("_Branch")
@@ -228,6 +215,21 @@
         branch_menu.add(gtk.MenuItem("Pu_ll Revisions"))
         branch_menu.add(gtk.MenuItem("Pu_sh Revisions"))
 
+        try:
+            from bzrlib.plugins import search
+        except ImportError:
+            mutter("Didn't find search plugin")
+        else:
+            branch_menu.add(gtk.SeparatorMenuItem())
+
+            branch_index_menuitem = gtk.MenuItem("_Index")
+            branch_index_menuitem.connect('activate', self._branch_index_cb)
+            branch_menu.add(branch_index_menuitem)
+
+            branch_search_menuitem = gtk.MenuItem("_Search")
+            branch_search_menuitem.connect('activate', self._branch_search_cb)
+            branch_menu.add(branch_search_menuitem)
+
         help_menu = gtk.Menu()
         help_menuitem = gtk.MenuItem("_Help")
         help_menuitem.set_submenu(help_menu)
@@ -319,6 +321,8 @@
         parents  = self.treeview.get_parents()
         children = self.treeview.get_children()
 
+        self.revision_menu.set_revision_ids([revision.revision_id])
+
         if revision and revision != NULL_REVISION:
             prev_menu = gtk.Menu()
             if len(parents) > 0:
@@ -378,19 +382,6 @@
         self.show_diff(revision.revision_id, parent_id)
         self.treeview.grab_focus()
         
-    def _menu_diff_cb(self,w):
-        (path, focus) = self.treeview.treeview.get_cursor()
-        revid = self.treeview.model[path][treemodel.REVID]
-        
-        parentids = self.branch.repository.revision_parents(revid)
-
-        if len(parentids) == 0:
-            parentid = NULL_REVISION
-        else:
-            parentid = parentids[0]
-        
-        self.show_diff(revid,parentid)    
-
     def _back_clicked_cb(self, *args):
         """Callback for when the back button is clicked."""
         self.treeview.back()
@@ -409,22 +400,6 @@
         self.show_diff(revid, parentid)
         self.treeview.grab_focus()
 
-    def _compare_with_cb(self,w):
-        """Callback for revision 'compare with' menu. Will show a small
-            dialog with branch revisions to compare with selected revision in TreeView"""
-        
-        from bzrlib.plugins.gtk.revbrowser import RevisionBrowser
-        
-        rb = RevisionBrowser(self.branch,self)
-        ret = rb.run()
-        
-        if ret == gtk.RESPONSE_OK:          
-            (path, focus) = self.treeview.treeview.get_cursor()
-            revid = self.treeview.model[path][treemodel.REVID]
-            self.show_diff(revid, rb.selected_revid)
-            
-        rb.destroy()
-            
     def _set_revision_cb(self, w, revision_id):
         self.treeview.set_revision_id(revision_id)
 
@@ -440,21 +415,18 @@
         self.treeview.set_property('compact', self.compact_view)
         self.treeview.refresh()
 
-    def _tag_revision_cb(self, w):
-        try:
-            self.treeview.set_sensitive(False)
-            dialog = AddTagDialog(self.branch.repository, self.treeview.get_revision().revision_id, self.branch)
-            response = dialog.run()
-            if response != gtk.RESPONSE_NONE:
-                dialog.hide()
-            
-                if response == gtk.RESPONSE_OK:
-                    self.treeview.add_tag(dialog.tagname, dialog._revid)
-                
-                dialog.destroy()
-
-        finally:
-            self.treeview.set_sensitive(True)
+    def _branch_index_cb(self, w):
+        from bzrlib.plugins.search import index as _mod_index
+        _mod_index.index_url(self.branch.base)
+
+    def _branch_search_cb(self, w):
+        from bzrlib.plugins.gtk.search import SearchDialog
+        dialog = SearchDialog(self.branch)
+        
+        if dialog.run() == gtk.RESPONSE_OK:
+            self.set_revision(dialog.get_revision())
+
+        dialog.destroy()
 
     def _about_dialog_cb(self, w):
         from bzrlib.plugins.gtk.about import AboutDialog

